﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows;
using System.Collections.ObjectModel;
using Infragistics.Controls.Menus;
using System.Data;
using System.Windows.Controls.Primitives;

namespace XamDataTreeMarker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xamDataTree1.ItemsSource = GenerateData().Tables[0].DefaultView;           
        }

        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
            data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");

            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("Name", typeof(string));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("ID", typeof(int));
            children.Columns.Add("Child", typeof(string));
            children.Columns.Add("Age", typeof(int));
            children.Columns.Add("Parent_ID", typeof(int));

            children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);


            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[3], false);

            for (int i = 1; i < 4; i++)
            {

                data.Tables["Parent"].Rows.Add(new object[] { i, "Parent" + i });
                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] {j, "Child" + j, j + i, i });
                }
            }

            data.AcceptChanges();

            return data;
        }

        private void ScrollBar_Loaded(object sender, RoutedEventArgs e)
        {
            if ((sender as ScrollBar).Orientation == Orientation.Horizontal)
            {
                (sender as ScrollBar).MinHeight = 0;
                (sender as ScrollBar).Height = 0;
            }
            else
                xamDataTree1.Tag = sender;
            
        }

        private void XamDataTreeNodeControl_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is TextBlock)
            {
                (sender as XamDataTreeNodeControl).Node.IsChecked = !(sender as XamDataTreeNodeControl).Node.IsChecked;
            }            
        }

    }

    public class WidthConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((Visibility)values[2] == Visibility.Collapsed)
            {
                return (double)values[1] - ((values[0] as XamDataTreeNodeControl).Node.Manager.Level * 21) - 55;
            }
            return (double)values[1] - ((values[0] as XamDataTreeNodeControl).Node.Manager.Level * 21) - 75;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
